org.apache.commons.io.filefilter

## Class SuffixFileFilter

- java.lang.Object
- - org.apache.commons.io.filefilter.AbstractFileFilter
  - - org.apache.commons.io.filefilter.SuffixFileFilter

- All Implemented Interfaces:
    FileFilter, FilenameFilter, Serializable, FileVisitor<Path>, PathMatcher, PathFilter, PathVisitor, IOFileFilter

      public class SuffixFileFilter
      extends AbstractFileFilter
      implements Serializable

  Filters files based on the suffix (what the file name ends with). This is used in retrieving all the files of a particular type.

  For example, to retrieve and print all `*.java` files in the current directory:

  ## Using Classic IO

       File dir = FileUtils.current();
       String[] files = dir.list(new SuffixFileFilter(".java"));
       for (String file : files) {
           System.out.println(file);
       }

  ## Using NIO

       final Path dir = PathUtils.current();
       final AccumulatorPathVisitor visitor = AccumulatorPathVisitor.withLongCounters(new SuffixFileFilter(".java"));
       //
       // Walk one directory
       Files.walkFileTree(dir, Collections.emptySet(), 1, visitor);
       System.out.println(visitor.getPathCounters());
       System.out.println(visitor.getFileList());
       //
       visitor.getPathCounters().reset();
       //
       // Walk directory tree
       Files.walkFileTree(dir, visitor);
       System.out.println(visitor.getPathCounters());
       System.out.println(visitor.getDirList());
       System.out.println(visitor.getFileList());

  ## Deprecating Serialization

  Serialization is deprecated and will be removed in 3.0.

  See Also:
    `FileFilterUtils.suffixFileFilter(String)`, `FileFilterUtils.suffixFileFilter(String, IOCase)`, Serialized Form

- - ### Field Summary

    - ### Fields inherited from interface org.apache.commons.io.filefilter.IOFileFilter

      `EMPTY_STRING_ARRAY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SuffixFileFilter(List<String> suffixes)` Constructs a new Suffix file filter for a list of suffixes.
    `SuffixFileFilter(List<String> suffixes, IOCase ioCase)` Constructs a new Suffix file filter for a list of suffixes specifying case-sensitivity.
    `SuffixFileFilter(String... suffixes)` Constructs a new Suffix file filter for an array of suffixes.
    `SuffixFileFilter(String suffix)` Constructs a new Suffix file filter for a single extension.
    `SuffixFileFilter(String[] suffixes, IOCase ioCase)` Constructs a new Suffix file filter for an array of suffixes specifying case-sensitivity.
    `SuffixFileFilter(String suffix, IOCase ioCase)` Constructs a new Suffix file filter for a single extension specifying case-sensitivity.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `accept(File file)` Tests to see if the file name ends with the suffix.
    `boolean` | `accept(File file, String name)` Tests to see if the file name ends with the suffix.
    `FileVisitResult` | `accept(Path path, BasicFileAttributes attributes)` Tests to see if the file name ends with the suffix.
    `String` | `toString()` Provides a String representation of this file filter.

    - ### Methods inherited from class org.apache.commons.io.filefilter.AbstractFileFilter

      `append, append, get, handle, isDirectory, isFile, postVisitDirectory, preVisitDirectory, toDefaultFileVisitResult, toFileVisitResult, visitFile, visitFileFailed`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.commons.io.filefilter.IOFileFilter

      `and, matches, negate, or`

- - ### Constructor Detail

    - #### SuffixFileFilter

          public SuffixFileFilter(List<String> suffixes)

      Constructs a new Suffix file filter for a list of suffixes.
      Parameters:
        `suffixes` - the suffixes to allow, must not be null
      Throws:
        `IllegalArgumentException` - if the suffix list is null
        `ClassCastException` - if the list does not contain Strings

    - #### SuffixFileFilter

          public SuffixFileFilter(List<String> suffixes,
                                  IOCase ioCase)

      Constructs a new Suffix file filter for a list of suffixes specifying case-sensitivity.
      Parameters:
        `suffixes` - the suffixes to allow, must not be null
        `ioCase` - how to handle case sensitivity, null means case-sensitive
      Throws:
        `IllegalArgumentException` - if the suffix list is null
        `ClassCastException` - if the list does not contain Strings

    - #### SuffixFileFilter

          public SuffixFileFilter(String... suffixes)

      Constructs a new Suffix file filter for an array of suffixes.

      The array is not cloned, so could be changed after constructing the instance. This would be inadvisable however.

      Parameters:
        `suffixes` - the suffixes to allow, must not be null
      Throws:
        `NullPointerException` - if the suffix array is null

    - #### SuffixFileFilter

          public SuffixFileFilter(String suffix)

      Constructs a new Suffix file filter for a single extension.
      Parameters:
        `suffix` - the suffix to allow, must not be null
      Throws:
        `IllegalArgumentException` - if the suffix is null

    - #### SuffixFileFilter

          public SuffixFileFilter(String[] suffixes,
                                  IOCase ioCase)

      Constructs a new Suffix file filter for an array of suffixes specifying case-sensitivity.
      Parameters:
        `suffixes` - the suffixes to allow, must not be null
        `ioCase` - how to handle case sensitivity, null means case-sensitive
      Throws:
        `NullPointerException` - if the suffix array is null

    - #### SuffixFileFilter

          public SuffixFileFilter(String suffix,
                                  IOCase ioCase)

      Constructs a new Suffix file filter for a single extension specifying case-sensitivity.
      Parameters:
        `suffix` - the suffix to allow, must not be null
        `ioCase` - how to handle case sensitivity, null means case-sensitive
      Throws:
        `NullPointerException` - if the suffix is null

  - ### Method Detail

    - #### accept

          public boolean accept(File file)

      Tests to see if the file name ends with the suffix.
      Specified by:
        `accept` in interface `FileFilter`
      Specified by:
        `accept` in interface `IOFileFilter`
      Overrides:
        `accept` in class `AbstractFileFilter`
      Parameters:
        `file` - the File to check
      Returns:
        true if the file name ends with one of our suffixes

    - #### accept

          public boolean accept(File file,
                                String name)

      Tests to see if the file name ends with the suffix.
      Specified by:
        `accept` in interface `FilenameFilter`
      Specified by:
        `accept` in interface `IOFileFilter`
      Overrides:
        `accept` in class `AbstractFileFilter`
      Parameters:
        `file` - the File directory
        `name` - the file name
      Returns:
        true if the file name ends with one of our suffixes

    - #### accept

          public FileVisitResult accept(Path path,
                                        BasicFileAttributes attributes)

      Tests to see if the file name ends with the suffix.
      Specified by:
        `accept` in interface `PathFilter`
      Specified by:
        `accept` in interface `IOFileFilter`
      Parameters:
        `path` - the File to check
        `attributes` - the path's basic attributes (may be null).
      Returns:
        true if the file name ends with one of our suffixes

    - #### toString

          public String toString()

      Provides a String representation of this file filter.
      Overrides:
        `toString` in class `AbstractFileFilter`
      Returns:
        a String representation